<?php

//	BlockHUB System
//	https://demo.blockhubsys.de
//	info@blockhubsys.de

session_start();

if (!isset($_SESSION['username'])) {
    header('Location: admin2.php');
    exit;
}

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    if (isset($_POST['title']) && isset($_POST['content'])) {
        $data = json_decode(file_get_contents('content.json'), true);

        if (isset($_POST['original_title'])) {
            foreach ($data['pages'] as &$page) {
                if ($page['title'] === $_POST['original_title']) {
                    $page['title'] = $_POST['title'];
                    $page['content'] = $_POST['content'];
                    break;
                }
            }
        } else {
            $newPage = [
                'title' => $_POST['title'],
                'content' => $_POST['content']
            ];
            $data['pages'][] = $newPage;
        }

        file_put_contents('content.json', json_encode($data, JSON_PRETTY_PRINT));
        header("Location: admin.php");
        exit;
    }

    if (isset($_POST['set_home'])) {
        $data = json_decode(file_get_contents('content.json'), true);
        $data['startpage'] = $_POST['set_home'];
        file_put_contents('content.json', json_encode($data, JSON_PRETTY_PRINT));
        header("Location: admin.php");
        exit;
    }
}

if (isset($_FILES['upload_file']) && $_FILES['upload_file']['error'] === UPLOAD_ERR_OK) {
    $uploadDir = 'uploads/';
    $uploadedFile = $uploadDir . 'logo' . '.' . pathinfo($_FILES['upload_file']['name'], PATHINFO_EXTENSION);
    move_uploaded_file($_FILES['upload_file']['tmp_name'], $uploadedFile);
}
    $uploadDir = 'uploads/';
    $logoFile = $uploadDir . 'logo';
    $extensions = ['.jpg', '.jpeg', '.png', '.gif', '.bmp'];
    $logoPath = '';
    foreach ($extensions as $ext) {
        if (file_exists($logoFile . $ext)) {
            $logoPath = $logoFile . $ext;
            break;
        }
    }
if (isset($_GET['delete_logo'])) {
    $uploadDir = 'uploads/';
    $bannerFile = $uploadDir . 'logo';
    $extensions = ['.jpg', '.jpeg', '.png', '.gif', '.bmp'];
    foreach ($extensions as $ext) {
        if (file_exists($bannerFile . $ext)) {
            unlink($bannerFile . $ext);
            break;
        }
    }
    header("Location: admin.php");
    exit;
}

if (isset($_FILES['banner_upload']) && $_FILES['banner_upload']['error'] === UPLOAD_ERR_OK) {
    $uploadDir = 'uploads/';
    $fileExtension = strtolower(pathinfo($_FILES['banner_upload']['name'], PATHINFO_EXTENSION));
    $allowedExtensions = ['jpg', 'jpeg', 'png', 'gif', 'bmp'];

    if (!in_array($fileExtension, $allowedExtensions)) {
        die('Invalid file extension.');
    }

    if (!is_writable($uploadDir)) {
        die('The directory is not writable.');
    }

    $bannerFile = $uploadDir . 'banner' . '.' . $fileExtension;

    if (move_uploaded_file($_FILES['banner_upload']['tmp_name'], $bannerFile)) {
        echo 'Upload successful!';
    } else {
        echo 'Error during upload.';
    }
}

if (isset($_GET['delete_banner'])) {
    $uploadDir = 'uploads/';
    $bannerFile = $uploadDir . 'banner';
    $extensions = ['.jpg', '.jpeg', '.png', '.gif', '.bmp'];

    foreach ($extensions as $ext) {
        if (file_exists($bannerFile . $ext)) {
            unlink($bannerFile . $ext);
            break;
        }
    }

    header("Location: admin.php");
    exit;
}


if (isset($_FILES['Favicon_upload']) && $_FILES['Favicon_upload']['error'] === UPLOAD_ERR_OK) {
    $uploadDir = 'uploads/';
    $faviconFile = $uploadDir . 'favicon' . '.' . pathinfo($_FILES['Favicon_upload']['name'], PATHINFO_EXTENSION);
    move_uploaded_file($_FILES['Favicon_upload']['tmp_name'], $faviconFile);
}
if (isset($_GET['delete_Favicon'])) {
    $uploadDir = 'uploads/';
    $faviconFile = $uploadDir . 'favicon';
    $extensions = ['.jpg', '.jpeg', '.png', '.gif', '.bmp'];
    foreach ($extensions as $ext) {
        if (file_exists($faviconFile . $ext)) {
            unlink($faviconFile . $ext);
            break;
        }
    }
    header("Location: admin.php");
    exit;
}
$faviconPath = 'uploads/favicon';
$extensions = ['.jpg', '.jpeg', '.png', '.gif', '.bmp'];
$faviconUrl = '';

foreach ($extensions as $ext) {
    if (file_exists($faviconPath . $ext)) {
        $faviconUrl = $faviconPath . $ext;
        break;
    }
}

$target_dir = "uploads/";
$target_file = $target_dir . basename($_FILES["fileToUpload"]["name"]);
$imageFileType = strtolower(pathinfo($target_file, PATHINFO_EXTENSION));
$uploadOk = 1;
$errorMessage = '';
$successMessage = '';
if(isset($_POST["submit"])) {
    $check = getimagesize($_FILES["fileToUpload"]["tmp_name"]);
    if($check !== false) {
        $successMessage = "File is an image - " . $check["mime"] . ".<br>";
    } else {
        $errorMessage .= "The file is not an image.<br>";
        $uploadOk = 0;
    }
}
if (file_exists($target_file)) {
    $errorMessage .= "Sorry, the file already exists.<br>";
    $uploadOk = 0;
}
if ($_FILES["fileToUpload"]["size"] > 5000000) {
    $errorMessage .= "Sorry, the file is too large.<br>";
    $uploadOk = 0;
}
if($imageFileType != "jpg" && $imageFileType != "png" && $imageFileType != "jpeg" && $imageFileType != "gif" ) {
    $errorMessage .= "Sorry, only JPG, JPEG, PNG and GIF files are allowed.<br>";
    $uploadOk = 0;
}
if ($uploadOk == 1) {
    if (move_uploaded_file($_FILES["fileToUpload"]["tmp_name"], $target_file)) {
        $successMessage .= "The file ". htmlspecialchars(basename($_FILES["fileToUpload"]["name"])) . " was uploaded successfully.<br>";
    } else {
        $errorMessage .= "Sorry, there was an error uploading the file.<br>";
    }
}
if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['action']) && $_POST['action'] === 'delete_image') {
    if (isset($_POST['imagePath'])) {
        $imagePath = $_POST['imagePath'];
        echo "Receive image path:" . $imagePath;
        if (file_exists($imagePath)) {
            if (unlink($imagePath)) {
                echo 'Image successfully deleted.';
            } else {
                echo 'Error deleting file. Check permissions.';
            }
        } else {
            echo 'Image does not exist or the path is incorrect.';
        }
    } else {
        echo 'No image path specified.';
    }

    exit;
}

if (isset($_GET['delete'])) {
    $data = json_decode(file_get_contents('content.json'), true);
    $titleToDelete = $_GET['delete'];
    foreach ($data['pages'] as $index => $page) {
        if ($page['title'] === $titleToDelete) {
            unset($data['pages'][$index]);
            break;
        }
    }
    file_put_contents('content.json', json_encode($data, JSON_PRETTY_PRINT));
    header("Location: admin.php");
    exit;
}

$titleToEdit = isset($_GET['edit']) ? $_GET['edit'] : null;
$pageToEdit = null;
$data = json_decode(file_get_contents('content.json'), true);

if ($titleToEdit) {
    foreach ($data['pages'] as $page) {
        if ($page['title'] === $titleToEdit) {
            $pageToEdit = $page;
            break;
        }
    }
}

$contentFile = 'data/cc.json';
$content = [];
if (file_exists($contentFile)) {
    $content = json_decode(file_get_contents($contentFile), true);
}
if (isset($_POST['cookiecompilation'])) {
    $content['cookiecompilation'] = $_POST['cookiecompilation'];
    file_put_contents($contentFile, json_encode($content, JSON_PRETTY_PRINT));
    echo "";
}
$cookiecompilation = isset($content['cookiecompilation']) ? $content['cookiecompilation'] : '';

// Website Title
$contentFile = 'content.json';
$content = [];
if (file_exists($contentFile)) {
    $content = json_decode(file_get_contents($contentFile), true);
}
if (isset($_POST['title'])) {
    $content['title'] = $_POST['title'];
    file_put_contents($contentFile, json_encode($content, JSON_PRETTY_PRINT));
    echo "";
}
$title = isset($content['title']) ? $content['title'] : '';

function bbcode_to_html($bbcode) {
    $bbcode = preg_replace('/\[b\](.*?)\[\/b\]/', '<strong>$1</strong>', $bbcode);
    $bbcode = preg_replace('/\[i\](.*?)\[\/i\]/', '<em>$1</em>', $bbcode);
    $bbcode = preg_replace('/\[u\](.*?)\[\/u\]/', '<u>$1</u>', $bbcode);
    $bbcode = preg_replace('/\[h3\](.*?)\[\/h3\]/s', '<span class="title1">$1</span>', $bbcode);
    $bbcode = preg_replace('/\[h4\](.*?)\[\/h4\]/s', '<span class="title2">$1</span>', $bbcode);
	$bbcode = preg_replace('/\[url=([^\]]+)\](.*?)\[\/url\]/', '<a href="$1">$2</a>', $bbcode);
	$bbcode = preg_replace('/\[li\](.*?)\[\/li\]/', '<li>$1</li>', $bbcode);
    return $bbcode;
}

function movePage($pageTitle, $direction) {
    global $data;
    $index = array_search($pageTitle, array_column($data['pages'], 'title'));

    if ($index !== false) {
        $newIndex = $index + $direction;
        if ($newIndex >= 0 && $newIndex < count($data['pages'])) {
            $temp = $data['pages'][$index];
            $data['pages'][$index] = $data['pages'][$newIndex];
            $data['pages'][$newIndex] = $temp;
            file_put_contents('content.json', json_encode($data, JSON_PRETTY_PRINT));
        }
    }
}

$dataDir = "data";
$userFile = $dataDir . "/users.json";

$message = '';

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $currentPassword = trim($_POST['current_password']);
    $newPassword = trim($_POST['new_password']);
    $repeatPassword = trim($_POST['repeat_password']);

    if (file_exists($userFile)) {
        $users = json_decode(file_get_contents($userFile), true);

        $username = $_SESSION['username'];

        if (isset($users[$username]) && password_verify($currentPassword, $users[$username])) {

            if ($newPassword === $repeatPassword) {

                $hashedPassword = password_hash($newPassword, PASSWORD_DEFAULT);
                $users[$username] = $hashedPassword;

                file_put_contents($userFile, json_encode($users));

                $message = "Password changed successfully!";
            } else {
                $message = "The new passwords do not match.";
            }
        } else {
            $message = "Current password is incorrect.";
        }
    } else {
        $message = "User data could not be loaded.";
    }
}
?>

<!DOCTYPE html>
<html lang="de">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Admin-Seite</title>
    <link rel="stylesheet" href="admin.css">
    <link rel="stylesheet" href="blocks/colums.css">
<style>
  .editor {
    width: 80%;
    min-height: 300px;
    border: 1px solid #ddd;
    padding: 10px;
    margin: 20px auto;
    font-size: 16px;
    line-height: 1.5;
    overflow-y: auto;
  }

  .floating-toolbar {
    position: absolute;
    display: none;
    background: #fff;
    border: 1px solid #ddd;
    border-radius: 5px;
    box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1);
    z-index: 1000;
    padding: 5px;
  }

  .floating-toolbar button {
    background: none;
    border: none;
    margin: 0 5px;
    font-size: 16px;
    cursor: pointer;
  }

  .floating-toolbar button:hover {
    color: #f20028;
  }
</style>

</head>
<body>
<p>...here you can log out again <a href="logout.php">Logout</a> or show your <a href="index.php" target="_blank">Current Website</a></p>

<fieldset id="edit-site">
 <p>
  <h3>Editor</h3><br>

	<form method="POST" enctype="multipart/form-data" action="#edit-site">

    <?php if ($pageToEdit): ?>
        <input type="hidden" name="original_title" value="<?php echo htmlspecialchars($pageToEdit['title']); ?>">
    <?php endif; ?>

    <label for="title">Titel & Link:</label>
    <input type="text" id="title" name="title" value="<?php echo $pageToEdit ? htmlspecialchars($pageToEdit['title']) : ''; ?>" class="editorinput"><div class="info-box">?<div class="info-text">Enter your page name here.<br>It is also the navigation name</div></div><br><br>
	</p>
	<div>
        <button type="button" onclick="insertBBCode('[b][/b]')" class="editorbutton1"><b>Bold</b></button>
        <button type="button" onclick="insertBBCode('[i][/i]')" class="editorbutton1"><i>Italics</i></button>
        <button type="button" onclick="insertBBCode('[u][/u]')" class="editorbutton2"><u>Underlined</u></button>
        <button type="button" onclick="insertBBCode('[h3][/h3]')" class="editorbutton1">Title Size 1</button>
        <button type="button" onclick="insertBBCode('[h4][/h4]')" class="editorbutton2">Title Size 2</button>
		<button type="button" onclick="insertURL()('[url=]Your Url Name[/url]')" class="editorbutton1">URL</button>
		<button type="button" onclick="insertBBCode('[li]Item one[/li][li]Item two[/li]')" class="editorbutton1">List</button>
	<p>
        <button type="button" onclick="setTextAlignment('left')" class="editorbutton3"><= Set Text Left</button>
        <button type="button" onclick="setTextAlignment('center')" class="editorbutton3">Set Text Center</button>
        <button type="button" onclick="setTextAlignment('right')" class="editorbutton7">Set Text Right =></button>
        <button type="button" onclick="openImageBrowser()" class="editorbutton6">Open Image Browser</button>
        <button type="button" onclick="changeImageSize(10)" class="editorbutton1">10% Size</button>
        <button type="button" onclick="changeImageSize(30)" class="editorbutton1">30% Size</button>
        <button type="button" onclick="changeImageSize(60)" class="editorbutton1">60% Size</button>
        <button type="button" onclick="changeImageSize(80)" class="editorbutton1">80% Size</button>
        <button type="button" onclick="changeImageSize(100)" class="editorbutton1">100% Size</button>
	</p>
        <button type="button" onclick="insertOneColumns()" class="editorbutton1">1 Block</button>
        <button type="button" onclick="insertTwoColumns()" class="editorbutton1">2 Blocks</button>
        <button type="button" onclick="insertThreeColumns()" class="editorbutton2">3 Blocks</button>
        <button type="button" onclick="insert3070Columns()" class="editorbutton1">30/70 Block</button>
        <button type="button" onclick="insert7030Columns2()" class="editorbutton2">70/30 Block</button>
        <button type="button" onclick="toggleBorderForSelectedColumn()" class="editorbutton1">Boarder On / Off</button>
        <button type="button" onclick="toggleBackgroundForSelectedColumn()" class="editorbutton2">Background On / Off</button>
        <button type="button" onclick="deleteSelectedColumn()" class="editorbutton5">Single Block Delete</button>
	</p>

<div id="imageBrowser" style="display: none; position: fixed; top: 10%; left: 10%; width: 80%; height: 80%; background: #fff; border: 1px solid #ccc; z-index: 1000; overflow-y: auto; box-shadow: 0px 4px 10px rgba(0, 0, 0, 0.5); border-radius: 8px;">
    <div id="dragArea" style="text-align: right; padding: 10px; background: #f4f4f4; border-bottom: 1px solid #ccc; cursor: move;">
        <button type="button" onclick="closeImageBrowser(event)">Close</button>
    </div>
    <div id="imageList" style="padding: 20px; display: flex; flex-wrap: wrap; gap: 10px;">
        <?php
        $uploadDir = 'uploads/';
        $files = glob($uploadDir . '*.{jpg,jpeg,png,gif}', GLOB_BRACE);
        foreach ($files as $file) {
            $filename = basename($file);
            echo '<div style="text-align: center;">';
            echo '<img src="' . $file . '" alt="' . $filename . '" style="max-width: 150px; max-height: 150px; border: 1px solid #ccc; cursor: pointer;" onclick="insertImage(\'' . $file . '\')">';
            echo '<p style="font-size: 12px; color: #666;">' . $filename . '</p>';
            echo '<button type="button" onclick="deleteImage(\'' . $file . '\', event)">Delete</button>';
            echo '</div>';
        }
        ?>
    </div>
</div>

<script>
let dragArea = document.getElementById('dragArea');
let imageBrowser = document.getElementById('imageBrowser');
let offsetX, offsetY;

dragArea.addEventListener('mousedown', function (event) {
    offsetX = event.clientX - imageBrowser.offsetLeft;
    offsetY = event.clientY - imageBrowser.offsetTop;

    document.addEventListener('mousemove', moveWindow);
    document.addEventListener('mouseup', stopMove);
});
function moveWindow(event) {
    imageBrowser.style.left = (event.clientX - offsetX) + 'px';
    imageBrowser.style.top = (event.clientY - offsetY) + 'px';
}
function stopMove() {
    document.removeEventListener('mousemove', moveWindow);
    document.removeEventListener('mouseup', stopMove);
}
function closeImageBrowser(event) {
    event.preventDefault();  // Verhindert das Standardverhalten, z.B. Formularabsendung
    event.stopPropagation(); // Verhindert die weitere Event-Ausbreitung
    imageBrowser.style.display = 'none'; // Schliet das Fenster
}


function deleteImage(imagePath, event) {
    event.preventDefault();

    if (confirm('Are you sure you want to delete this image?')) {
        console.log('Try deleting this image:', imagePath);
        const xhr = new XMLHttpRequest();
        xhr.open('POST', 'admin.php', true);
        xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        xhr.onload = function () {
            if (xhr.status === 200) {
                location.reload();
            } else {
                alert('Error deleting image.');
            }
        };
        xhr.send('action=delete_image&imagePath=' + encodeURIComponent(imagePath));
    }
}
</script>

	</div>
	</p><br>
    <label for="content">Content</label><br>
    <div id="editableArea" class="editor-container" contenteditable="true">
        <?php echo $pageToEdit ? htmlspecialchars_decode($pageToEdit['content']) : ''; ?>
    </div>

 </div>
 <p>
 	<input type="hidden" id="hiddenContent" name="content">
    <button type="submit" style="width:100px;" class="editorbutton1"><?php echo $pageToEdit ? 'Save Content' : 'Save Content'; ?></button>

	</form>

 </p>

<h4 style="margin-top:30px;">Current Pages</h4>
 <p>
 <ul>
    <?php
    if (isset($_GET['move_up'])) {
        movePage($_GET['move_up'], -1);
    }
    if (isset($_GET['move_down'])) {
        movePage($_GET['move_down'], 1);
    }
    foreach ($data['pages'] as $index => $page) {
        echo '<li style="margin-top:10px;">&nbsp;' . htmlspecialchars($page['title']);
        echo ' - <a href="admin.php?edit=' . urlencode($page['title']) . '">Edit Page</a> | ';
        echo ' <a href="admin.php?delete=' . urlencode($page['title']) . '" onclick="return confirm(\'Are you sure you want to delete this page?\');">Delete</a>';
        if ($index > 0) {
            echo ' | <a href="admin.php?move_up=' . urlencode($page['title']) . '">Move Up</a>';
        }
        if ($index < count($data['pages']) - 1) {
            echo ' | <a href="admin.php?move_down=' . urlencode($page['title']) . '">Move Down</a>';
        }
        if (isset($data['startpage']) && $data['startpage'] === $page['title']) {
            echo ' | Current Start Page';
        } else {
            echo ' | <form method="POST" style="display:inline;">
                <input type="hidden" name="set_home" value="' . htmlspecialchars($page['title']) . '">
                <button type="submit" class="editorbutton4">Set Start Page</button>
            </form>';
        }

        echo '</li>';
    }
    ?>

 </ul><br>

 <p>
    <div style="display: flex; width:100%;">
     <div style="text-align:left; width:100%;"><a href="index.php" target="_blank">Show Current Website</a></div>
     <div style="text-align:right; width:100%;"><a href="admin.php">Go to Top & Reload</a></div>
    </div>

 </p>
</fieldset>
 <p>

<fieldset id="logo-upload">
 <p>
  <h3>Logo Upload</h3><br>
<form method="POST" enctype="multipart/form-data" action="#logo-upload">
  <label for="upload_file" class="custom-upload">Search File</label>
  <input type="file" name="upload_file" id="upload_file">
  <p><button type="submit" class="editorbutton4">Upload Logo</button></p>
</form>
 </p>

    <?php if ($logoPath): ?>
        <img src="<?php echo htmlspecialchars($logoPath); ?>" alt="Logo" style="max-width:50px; height:auto;">
        <br>
        <a href="admin.php?delete_logo=1" onclick="return confirm('Are you sure you want to delete the logo?');">Logo Delete</a>
    <?php else: ?>
        <p>No logo available.</p>
    <?php endif; ?>

 <br>
    <div style="display: flex; width:100%;">
     <div style="text-align:left; width:100%;"></div>
     <div style="text-align:right; width:100%;"><a href="admin.php">Go to Top & Reload</a></div>
    </div>

</fieldset>
</p>

<fieldset id="header-upload">
    <p>
        <h3>Header Upload</h3><br>
        <form method="POST" enctype="multipart/form-data" action="#header-upload">
            <label for="upload_file" class="custom-upload">Search File</label>
            <input type="file" name="banner_upload" id="banner_upload">
            <p><button type="submit" class="editorbutton4">Upload Header</button></p>
        </form>
    </p>
    <a href="admin.php?delete_banner=1" onclick="return confirm('Are you sure you want to delete the header?');">Header Delete</a>
 <br>
    <div style="display: flex; width:100%;">
     <div style="text-align:left; width:100%;"></div>
     <div style="text-align:right; width:100%;"><a href="admin.php">Go to Top & Reload</a></div>
    </div>

</fieldset>

<br>

<fieldset id="favicon-upload">
 <p>
  <h3>FavIcon Upload</h3><br>
    <form action="#favicon-upload" method="post" enctype="multipart/form-data">
   	<label for="upload_file" class="custom-upload">Search File</label>
        <input type="file" name="Favicon_upload" id="Favicon_upload" accept=".jpg,.jpeg,.png,.gif,.bmp">
        <p><button type="submit" class="editorbutton4">FavIcon Upload</button></p>
    </form>
 </p>

    <?php if ($faviconUrl): ?>
        <img src="<?php echo $faviconUrl; ?>" alt="Favicon" style="width: 32px; height: 32px;">
        <br>
        <a href="?delete_Favicon=true">Favicon Delete</a>
    <?php else: ?>
    <?php endif; ?>

 <br>
    <div style="display: flex; width:100%;">
     <div style="text-align:left; width:100%;"></div>
     <div style="text-align:right; width:100%;"><a href="admin.php">Go to Top & Reload</a></div>
    </div>

</fieldset>

 <br>

<fieldset id="title-form">
 <p>
  <h3>Website Title</h3><br>
    <form action="#title-form" method="post">
        <label for="title">Title:</label>
        <input type="text" name="title" id="title" value="<?php echo htmlspecialchars($title); ?>" required class="editorinput">
        <button type="submit" class="editorbutton6">Save</button>
    </form>
 <br>
    <div width="100%">
     <div width="100%" style="text-align:left;"><a href="index.php" target="_blank">Show Current Website</a></div>
     <div width="100%" style="text-align:right;"><a href="admin.php">Go to Top & Reload</a></div>
    </div>

</fieldset>

<br>

<fieldset id="cookie-compilation">
 <p>
  <h3>Cookie Compilation</h3><br>
    <form action="#cookie-compilation" method="post">
        <label for="cookiecompilation">Cookie Compilation:</label>
        <input type="cookiecompilation" name="cookiecompilation" id="cookiecompilation" value="<?php echo htmlspecialchars($cookiecompilation); ?>" required class="editorinput">
        <button type="submit" class="editorbutton6">Save</button>
    </form>
 <br>
    <div style="display: flex; width:100%;">
     <div style="text-align:left; width:100%;"></div>
     <div style="text-align:right; width:100%;"><a href="admin.php">Go to Top & Reload</a></div>
    </div>

</fieldset>

<br>

<fieldset id="upload-image">
 <p>
  <h3>Image Upload</h3><br>
 <form action="#upload-image" method="post" enctype="multipart/form-data">
    <label for="fileToUpload">Select an image:</label>
    <input type="file" name="fileToUpload" id="fileToUpload" accept=".jpg,.jpeg,.png,.gif,.bmp"></p><br>
    <p><div style="width:100%"><button type="submit" class="editorbutton4">Image Upload</button>
</form>
 <button type="button" onclick="openImageBrowser()" class="editorbutton2">Open Image Browser</button></div>
 <br>
    <div style="display: flex; width:100%;">
     <div style="text-align:left; width:100%;"></div>
     <div style="text-align:right; width:100%;"><a href="admin.php">Go to Top & Reload</a></div>
    </div>

</fieldset>

<br>

<fieldset id="change-password">
 <p>
  <h3>Change Password *</h3><br>
<form action="#change-password">
    <label>Current Password:</label><br>
    <input class="editorinput" type="password" name="current_password" required><br>

    <label>New Password:</label><br>
    <input class="editorinput" type="password" name="new_password" required><br>

    <label>Repeat New Password:</label><br>
    <input class="editorinput" type="password" name="repeat_password" required>

    <p><button type="submit" class="editorbutton2">Change Password</button></p>
</form>
<br>* Disabled in the demo
<?php if ($message): ?>
    <p><?php echo htmlspecialchars($message); ?></p>
<?php endif; ?>
<br>
    <div style="display: flex; width:100%;">
     <div style="text-align:left; width:100%;"></div>
     <div style="text-align:right; width:100%;"><a href="admin.php">Go to Top & Reload</a></div>
    </div>

</fieldset>

<script>
  // Auf deinen Editor abgestimmt
  const editor = document.getElementById('editableArea');
  const toolbar = document.getElementById('toolbar');

  // Event: Wenn die Maus losgelassen wird (Textauswahl abgeschlossen)
  editor.addEventListener('mouseup', function () {
    const selection = window.getSelection();

    // Prfen, ob tatschlich Text markiert wurde
    if (selection.rangeCount > 0 && !selection.isCollapsed) {
      const range = selection.getRangeAt(0);
      const rect = range.getBoundingClientRect();

      // Toolbar an der Position der Markierung anzeigen
      toolbar.style.left = `${rect.left + window.pageXOffset}px`;
      toolbar.style.top = `${rect.top + window.pageYOffset - toolbar.offsetHeight - 10}px`;
      toolbar.style.display = 'block';
    } else {
      toolbar.style.display = 'none';
    }
  });

  // Event: Wenn die Maus gedrckt wird (z. B. neue Markierung beginnt)
  editor.addEventListener('mousedown', function () {
    toolbar.style.display = 'none';
  });

  // Funktion: Stil anwenden (z. B. fett, kursiv, unterstrichen)
  function applyStyle(command) {
    document.execCommand(command);
    toolbar.style.display = 'none';
  }
</script>
</body>
</html>

<script>
function ensureFocusInEditableArea() {
    const editableArea = document.getElementById('editableArea');
    if (document.activeElement !== editableArea) {
        editableArea.focus(); // Fokus explizit setzen
    }
}

document.querySelector('form').addEventListener('submit', function(event) {
    const editableArea = document.getElementById('editableArea');
    const hiddenContent = document.getElementById('hiddenContent');
    const cleanHTML = editableArea.innerHTML.replace(/style="[^"]*border[^"]*"/g, '');
    hiddenContent.value = cleanHTML;
});

let selectedColumn = null;

function insertOneColumns() {
    const colLayout = `
        <div class="col-container">
            <div class="col" contenteditable="true" onclick="selectColumn(this)">1 Block</div>
        </div>
    `;
    insertToEditorAtCaret(colLayout);
    insertEmptyLine();
}

function insertTwoColumns() {
    const colLayout = `
        <div class="col-container">
            <div class="col" contenteditable="true" onclick="selectColumn(this)">Left Block</div>
            <div class="col" contenteditable="true" onclick="selectColumn(this)">Right block</div>
        </div>
    `;
    insertToEditorAtCaret(colLayout);
    insertEmptyLine();
}

function insertThreeColumns() {
    const colLayout = `
        <div class="col-container">
            <div class="col" contenteditable="true" onclick="selectColumn(this)">Left Block</div>
            <div class="col" contenteditable="true" onclick="selectColumn(this)">Center Block</div>
            <div class="col" contenteditable="true" onclick="selectColumn(this)">Right Block</div>
        </div>
    `;
    insertToEditorAtCaret(colLayout);
    insertEmptyLine();
}

function insert3070Columns() {
    const colLayout = `
        <div class="col-container">
            <div class="col left" contenteditable="true" onclick="selectColumn(this)">Left Block</div>
            <div class="col right" contenteditable="true" onclick="selectColumn(this)">Right block</div>
        </div>
    `;
    insertToEditorAtCaret(colLayout);
    insertEmptyLine();
}

function insert7030Columns2() {
    const colLayout = `
        <div class="col-container">
            <div class="col left2" contenteditable="true" onclick="selectColumn(this)">Left Block</div>
            <div class="col right2" contenteditable="true" onclick="selectColumn(this)">Right block</div>
        </div>
    `;
    insertToEditorAtCaret(colLayout);
    insertEmptyLine();
}

function insertToEditorAtCaret(html) {
    const editableArea = document.getElementById('editableArea');
    const selection = window.getSelection();
    const range = selection.getRangeAt(0);

    range.deleteContents();

    const div = document.createElement('div');
    div.innerHTML = html;

    range.insertNode(div);

    range.setStartAfter(div);
    range.setEndAfter(div);
    selection.removeAllRanges();
    selection.addRange(range);
}

function insertEmptyLine() {
    const editableArea = document.getElementById('editableArea');
    const emptyLine = document.createElement('div');
    emptyLine.setAttribute('contenteditable', 'true');
    emptyLine.innerHTML = '';
    editableArea.appendChild(emptyLine);

    const selection = window.getSelection();
    const range = document.createRange();
    range.selectNode(emptyLine);
    selection.removeAllRanges();
    selection.addRange(range);
}

function selectColumn(colElement) {
    selectedColumn = colElement;

    const allCols = document.querySelectorAll('.col');
    allCols.forEach(col => {
        col.style.border = '';
        col.classList.remove('selected-column');
    });

    colElement.classList.add('selected-column');
    colElement.style.border = '2px solid #f00';
}

function deleteSelectedColumn() {
    if (selectedColumn) {
        const colContainer = selectedColumn.parentNode;
        colContainer.removeChild(selectedColumn);
        // Falls keine Spalten mehr brig sind, Container lschen
        if (colContainer.children.length === 0) {
            colContainer.remove();
        }
        selectedColumn = null;
    } else {
        alert('Keine Spalte ausgewhlt!');
    }
}

function toggleBackgroundForSelectedColumn() {
    if (selectedColumn) {
        // Prfe, ob die Spalte einen Hintergrund hat
        if (selectedColumn.classList.contains('background-hidden')) {
            selectedColumn.classList.remove('background-hidden');
            selectedColumn.style.backgroundColor = '';
        } else {
            selectedColumn.classList.add('background-hidden');
            selectedColumn.style.backgroundColor = 'transparent';
        }
        selectedColumn.style.border = '2px solid #f00';
    } else {
        alert('Keine Spalte ausgewhlt!');
    }
}

function toggleBorderForSelectedColumn() {
    if (selectedColumn) {
        // Prfe, ob die Spalte einen Rahmen hat
        if (selectedColumn.classList.contains('column-border')) {
            selectedColumn.classList.remove('column-border');
        } else {
            selectedColumn.classList.add('column-border');
        }

        // Markierung der Spalte (rot) bleibt bestehen
        selectedColumn.style.border = '2px solid #f00';
    } else {
        alert('Keine Spalte ausgewhlt!');
    }
}

function setTextAlignment(alignment) {
    console.log('setTextAlignment wird ausgefhrt');
    console.log('selectedColumn:', selectedColumn);
    const editableArea = document.getElementById('editableArea');
    if (editableArea) {
        if (window.getSelection) {
            const selection = window.getSelection();
            const range = selection.getRangeAt(0);

            const selectedText = selection.toString();

            if (selectedText) {
                document.execCommand('justify' + alignment, false, null);
            } else {
                alert('Bitte whle einen Text aus!');
            }
        } else {
            alert('Dein Browser untersttzt keine Textauswahl.');
        }
    } else {
        alert('Das Editor-Feld wurde nicht gefunden!');
    }
}

function insertImageIntoColumn(imageUrl) {
    if (!selectedColumn) {
        alert('Bitte whle zuerst eine Spalte aus!');
        return;
    }

    const imageContainer = document.createElement('div');
    imageContainer.style.width = '100%';
    imageContainer.style.height = '100%';
    imageContainer.style.display = 'flex';
    imageContainer.style.justifyContent = 'center';
    imageContainer.style.alignItems = 'center';

    const imageElement = document.createElement('img');
    imageElement.src = imageUrl;
    imageElement.alt = 'Inserted Image';
    imageElement.className = 'myimage'; // Klasse explizit setzen
    imageElement.style.maxWidth = '30%'; // Standardgre 30%

    imageContainer.appendChild(imageElement);
    selectedColumn.appendChild(imageContainer);
}

function openImageBrowser() {
    document.getElementById('imageBrowser').style.display = 'block';
}

function closeImageBrowser() {
    document.getElementById('imageBrowser').style.display = 'none';
}

function selectColumn(colElement) {
    selectedColumn = colElement;

    const allCols = document.querySelectorAll('.col');
    allCols.forEach(col => {
        col.style.border = '';
        col.classList.remove('selected-column');
    });

    colElement.classList.add('selected-column');
    colElement.style.border = '0px solid #f00';
}

function changeImageSize(percentage) {
    if (!selectedColumn) {
        alert('Please select a column first!');
        return;
    }
    const imageElement = selectedColumn.querySelector('img');
    if (imageElement) {
        // Setzt die max-width auf den angegebenen Prozentsatz
        imageElement.style.maxWidth = percentage + '%';
    } else {
        alert('No image found in the selected column!');
    }
}

document.addEventListener('keydown', function (event) {
    // Prfen, ob die Enter-Taste gedrckt wurde
    if (event.key === 'Enter') {
        // Verhindert das Standardverhalten (neue Zeile)
        event.preventDefault();

        // Fge ein Zeilenumbruch <br> ein
        const selection = window.getSelection();
        const range = selection.getRangeAt(0);
        const br = document.createElement('br');

        range.insertNode(br);

        // Setze den Cursor nach dem <br>
        range.setStartAfter(br);
        range.setEndAfter(br);
        selection.removeAllRanges();
        selection.addRange(range);
    }
});

function insertBBCode(code) {
    const selection = window.getSelection();
    const range = selection.getRangeAt(0);
    const selectedText = selection.toString();

    if (selectedText) {
        const tagStart = code.split('[')[1].split(']')[0];
        const tagEnd = '/' + tagStart;

        if (selectedText.startsWith('[' + tagStart + ']') && selectedText.endsWith('[' + tagEnd + ']')) {
            selectedText = selectedText.slice(('[' + tagStart + ']').length, -('[' + tagEnd + ']').length);
        }

        const newText = '[' + tagStart + ']' + selectedText + '[' + tagEnd + ']';
        range.deleteContents();
        range.insertNode(document.createTextNode(newText));
    } else {
        const newText = code;
        range.deleteContents();
        range.insertNode(document.createTextNode(newText));
    }
}

function insertURL() {
    const selection = window.getSelection();
    const range = selection.getRangeAt(0);
    const selectedText = selection.toString();
    const url = prompt('Please enter the URL:', 'https://');

    if (url) {
        if (selectedText) {
            const newBBCode = `[url=${url}]${selectedText}[/url]`;
            range.deleteContents();
            range.insertNode(document.createTextNode(newBBCode));
        } else {
            const newBBCode = `[url=${url}]Your Url Name[/url]`;
            range.deleteContents();
            range.insertNode(document.createTextNode(newBBCode));
        }
    }
}


</script>